SystemOrganization addCategory: #SortingVisualizer!

BorderedMorph subclass: #SVSortItemVisualizer
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SortingVisualizer'!

!SVSortItemVisualizer class methodsFor: 'as yet unclassified' stamp: 'rms 5/23/2013 15:37:46.913'!
newSortVisualizerFor: items

	| visualizer |
	visualizer := self new.
	^visualizer setupFrameWithExtent: 400@300;
			    setupSortingScape: items asOrderedCollection;
				 openInWorld;
				 yourself
	! !

!SVSortItemVisualizer methodsFor: 'as yet unclassified' stamp: 'rms 5/23/2013 16:04:19.803'!
createNewTower: maxValue and: width and: value at: offset

	| newTower |
	newTower := SVTower newWith: maxValue and: width and: value.
	newTower position: self position + offset.
	items addLast: newTower. 
	self addMorphFront: newTower.! !

!SVSortItemVisualizer methodsFor: 'as yet unclassified' stamp: 'rms 5/23/2013 14:49:02.261'!
initialize
	super initialize.
	self items: OrderedCollection new.! !

!SVSortItemVisualizer methodsFor: 'as yet unclassified' stamp: 'rms 5/23/2013 14:12:39.821'!
items
	^items! !

!SVSortItemVisualizer methodsFor: 'as yet unclassified' stamp: 'rms 5/23/2013 14:11:12.808'!
items: anArray
	items := anArray.! !

!SVSortItemVisualizer methodsFor: 'as yet unclassified' stamp: 'rms 5/23/2013 14:07:28.874'!
setupFrameWithExtent: extent

	self extent: extent.
	self color: Color white.
	self borderColor: Color black.! !

!SVSortItemVisualizer methodsFor: 'as yet unclassified' stamp: 'rms 5/23/2013 15:31:47.037'!
setupSortingScape: sortingItems

	| towerOffset towerWidth towerHeight|
	
	towerWidth := self width / sortingItems size.
	towerOffset := 0@0.
	
	sortingItems do: [:item |
		towerHeight := self height / item.
		self createNewTower: self height
						  and: towerWidth 
						  and: towerHeight
						  at: towerOffset.
		towerOffset := towerOffset + (towerWidth@0)].! !

!SVSortItemVisualizer methodsFor: 'as yet unclassified' stamp: 'rms 5/23/2013 16:00:36.548'!
swap: firstIndex with: secondIndex

	| tmpTower |
	
	(self items at: firstIndex) 
			moveTo: (self items at: secondIndex) position.
	(self items at: secondIndex) 
			moveTo: (self items at: firstIndex) position. 
	
	tmpTower := self items at: firstIndex.
	self items at: firstIndex put: (self items at: secondIndex).
	self items at: secondIndex put: tmpTower.
	  			! !

Morph subclass: #SVTower
	instanceVariableNames: 'corpus topMorph value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SortingVisualizer'!

!SVTower class methodsFor: 'as yet unclassified' stamp: 'rms 5/23/2013 16:09:27.829'!
newWith: maxValue and: width and: value

	| newTower |
	newTower := self new.
	newTower extent: width@maxValue;
	         color: Color transparent;
			  corpus: Morph new;
			  value: value.
	(newTower corpus) color: Color gray;
						 height: value;
						 width: width.
	newTower topMorph: Morph new.
	(newTower topMorph) color: Color black;
					 height: width;
					 width: width;
					 position: newTower corpus position.
	newTower corpus addMorphFront: newTower topMorph.
	newTower corpus position:  
		newTower corpus position + (0@(maxValue - value)).
	newTower addMorphFront: newTower corpus.
	^ newTower.! !

!SVTower methodsFor: 'as yet unclassified' stamp: 'rms 5/23/2013 13:21:50.395'!
corpus
	^corpus! !

!SVTower methodsFor: 'as yet unclassified' stamp: 'rms 5/23/2013 13:22:00.376'!
corpus: aMorph
	corpus := aMorph.! !

!SVTower methodsFor: 'as yet unclassified' stamp: 'rms 5/23/2013 16:10:47.682'!
moveTo: newPosition

	(AnimPropertyAnimation on: self 
							 property: #position 
							 start: self position 
							 end: newPosition
							 duration: 300) register;
							 start. ! !

!SVTower methodsFor: 'as yet unclassified' stamp: 'rms 5/23/2013 15:02:39.707'!
topMorph
	^topMorph! !

!SVTower methodsFor: 'as yet unclassified' stamp: 'rms 5/23/2013 15:03:04.237'!
topMorph: aMorph
	topMorph := aMorph.! !

!SVTower methodsFor: 'as yet unclassified' stamp: 'rms 5/23/2013 15:41:51.965'!
value
	^value! !

!SVTower methodsFor: 'as yet unclassified' stamp: 'rms 5/23/2013 16:12:16.481'!
value: val
	value := val.! !
